package it.sw.pa.comune.artegna.service;

import it.sw.pa.comune.artegna.domain.*; // for static metamodels
import it.sw.pa.comune.artegna.domain.Prenotazione;
import it.sw.pa.comune.artegna.repository.PrenotazioneRepository;
import it.sw.pa.comune.artegna.service.criteria.PrenotazioneCriteria;
import it.sw.pa.comune.artegna.service.dto.PrenotazioneDTO;
import it.sw.pa.comune.artegna.service.mapper.PrenotazioneMapper;
import jakarta.persistence.criteria.JoinType;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.domain.Specification;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import tech.jhipster.service.QueryService;

/**
 * Service for executing complex queries for {@link Prenotazione} entities in the database.
 * The main input is a {@link PrenotazioneCriteria} which gets converted to {@link Specification},
 * in a way that all the filters must apply.
 * It returns a {@link Page} of {@link PrenotazioneDTO} which fulfills the criteria.
 */
@Service
@Transactional(readOnly = true)
public class PrenotazioneQueryService extends QueryService<Prenotazione> {

    private static final Logger LOG = LoggerFactory.getLogger(PrenotazioneQueryService.class);

    private final PrenotazioneRepository prenotazioneRepository;

    private final PrenotazioneMapper prenotazioneMapper;

    public PrenotazioneQueryService(PrenotazioneRepository prenotazioneRepository, PrenotazioneMapper prenotazioneMapper) {
        this.prenotazioneRepository = prenotazioneRepository;
        this.prenotazioneMapper = prenotazioneMapper;
    }

    /**
     * Return a {@link Page} of {@link PrenotazioneDTO} which matches the criteria from the database.
     * @param criteria The object which holds all the filters, which the entities should match.
     * @param page The page, which should be returned.
     * @return the matching entities.
     */
    @Transactional(readOnly = true)
    public Page<PrenotazioneDTO> findByCriteria(PrenotazioneCriteria criteria, Pageable page) {
        LOG.debug("find by criteria : {}, page: {}", criteria, page);
        final Specification<Prenotazione> specification = createSpecification(criteria);
        return prenotazioneRepository.findAll(specification, page).map(prenotazioneMapper::toDto);
    }

    /**
     * Return the number of matching entities in the database.
     * @param criteria The object which holds all the filters, which the entities should match.
     * @return the number of matching entities.
     */
    @Transactional(readOnly = true)
    public long countByCriteria(PrenotazioneCriteria criteria) {
        LOG.debug("count by criteria : {}", criteria);
        final Specification<Prenotazione> specification = createSpecification(criteria);
        return prenotazioneRepository.count(specification);
    }

    /**
     * Function to convert {@link PrenotazioneCriteria} to a {@link Specification}
     * @param criteria The object which holds all the filters, which the entities should match.
     * @return the matching {@link Specification} of the entity.
     */
    protected Specification<Prenotazione> createSpecification(PrenotazioneCriteria criteria) {
        Specification<Prenotazione> specification = Specification.unrestricted();
        if (criteria != null) {
            // This has to be called first, because the distinct method returns null
            specification = Specification.allOf(
                Boolean.TRUE.equals(criteria.getDistinct()) ? distinct(criteria.getDistinct()) : null,
                buildRangeSpecification(criteria.getId(), Prenotazione_.id),
                buildRangeSpecification(criteria.getOraInizio(), Prenotazione_.oraInizio),
                buildRangeSpecification(criteria.getOraFine(), Prenotazione_.oraFine),
                buildSpecification(criteria.getStato(), Prenotazione_.stato),
                buildStringSpecification(criteria.getMotivoEvento(), Prenotazione_.motivoEvento),
                buildRangeSpecification(criteria.getNumeroPartecipanti(), Prenotazione_.numeroPartecipanti),
                buildStringSpecification(criteria.getNoteUtente(), Prenotazione_.noteUtente),
                buildSpecification(criteria.getConfermaId(), root -> root.join(Prenotazione_.conferma, JoinType.LEFT).get(Conferma_.id)),
                buildSpecification(criteria.getUtenteId(), root -> root.join(Prenotazione_.utente, JoinType.LEFT).get(UtenteApp_.id)),
                buildSpecification(criteria.getStrutturaId(), root -> root.join(Prenotazione_.struttura, JoinType.LEFT).get(Struttura_.id))
            );
        }
        return specification;
    }
}
